VERSION 5.00
Begin VB.Form frmHaupt 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Absenkungsberechnung"
   ClientHeight    =   5970
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7365
   Icon            =   "frmHaupt.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5970
   ScaleWidth      =   7365
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdRechnen 
      Caption         =   "&Berechnen"
      Height          =   375
      Left            =   3120
      TabIndex        =   7
      Top             =   5280
      Width           =   2055
   End
   Begin VB.ListBox lstErgebnis 
      BeginProperty Font 
         Name            =   "MS Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3420
      Left            =   2520
      TabIndex        =   9
      Top             =   360
      Width           =   4815
   End
   Begin VB.Frame Frame1 
      Caption         =   "Eingangswerte"
      Height          =   5655
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   2175
      Begin VB.TextBox txtVpkt 
         Height          =   495
         Left            =   120
         TabIndex        =   15
         ToolTipText     =   "Geben Sie hier den Volumenstrom ein !"
         Top             =   1920
         Width           =   1815
      End
      Begin VB.TextBox txtZeitpunkt 
         Height          =   375
         Left            =   120
         TabIndex        =   13
         ToolTipText     =   "Geben sie hier den Zeitpunkt ein!"
         Top             =   3600
         Width           =   1815
      End
      Begin VB.TextBox txtEntfernung 
         Height          =   375
         Left            =   120
         TabIndex        =   11
         ToolTipText     =   "Geben Sie hier die Entfernung ein !"
         Top             =   2760
         Width           =   1815
      End
      Begin VB.CheckBox chkGWLArt 
         Caption         =   "&ungespannter GWL ?"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   4200
         Width           =   2055
      End
      Begin VB.TextBox txtGWLArt 
         BackColor       =   &H0080FFFF&
         ForeColor       =   &H00FF0000&
         Height          =   495
         Left            =   120
         TabIndex        =   6
         ToolTipText     =   "Geben sie hier die Anfangswasserhhe oder Mchtigkeit ein!"
         Top             =   5040
         Width           =   1815
      End
      Begin VB.TextBox txtS_Wert 
         BackColor       =   &H00E0E0E0&
         ForeColor       =   &H00FF0000&
         Height          =   375
         Left            =   120
         TabIndex        =   3
         ToolTipText     =   "Geben Sie hier den S-Wert ein!"
         Top             =   1200
         Width           =   1815
      End
      Begin VB.TextBox txtkfT_Wert 
         BackColor       =   &H00E0E0E0&
         ForeColor       =   &H00FF0000&
         Height          =   375
         Left            =   120
         TabIndex        =   1
         ToolTipText     =   "Geben Sie hier den k- oder T-Wert ein!"
         Top             =   480
         Width           =   1815
      End
      Begin VB.Label Label7 
         Caption         =   "Anfangswasserhhe oder Mchtigkeit"
         Height          =   495
         Left            =   120
         TabIndex        =   16
         Top             =   4560
         Width           =   1815
      End
      Begin VB.Label Label6 
         Caption         =   "Zeitpunkt"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   3360
         Width           =   975
      End
      Begin VB.Label Label5 
         Caption         =   "Entfernungsbereich"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   2520
         Width           =   1815
      End
      Begin VB.Label Label3 
         Caption         =   "&Volumenstrom:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   1680
         Width           =   1215
      End
      Begin VB.Label Label2 
         Caption         =   "&S-Wert:"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   960
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "&k-/T-Wert:"
         Height          =   255
         Left            =   120
         TabIndex        =   0
         Top             =   240
         Width           =   735
      End
   End
   Begin VB.Label Label4 
      Caption         =   "Das Ergebnis der Berechnung:"
      Height          =   255
      Left            =   2520
      TabIndex        =   8
      Top             =   120
      Width           =   2415
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' **********************************
'       Absenkungsberechnung
'               mit
'        vollstndiger Eingabe
'
'
'
' **********************************
Option Explicit
' Durch das Anklicken des Kontrollkstchens Monatszahlung
' wird das Textfeld aktiviert/deaktiviert
Private Sub chkGWLArt_Click()
    txtGWLArt.Enabled = CBool(chkGWLArt.Value)
End Sub
' Das Anklicken des Buttons cmdRechnen startet die Berechnung
Private Sub cmdRechnen_Click()
  Dim kfT_Wert As Double, S_Wert As Double, Vpkt As Double
  Dim Entfernung As Double, MaxEntfernung As Double, EntfernungFeld(11) As Double
  Dim Zeitpunkt As Double
  Dim Absenk(11) As Double, Sigma As Double, Wvsigma As Double
  Dim num As Integer, n As Integer, dif As Double, Wvsigalt As Double
  Dim zrn As Double
  Const Gamma = 1.7810724, Pi = 3.14159265
' Prfen, ob fr kfT_Wert ein Wert eingegeben wurde
  If Len(txtkfT_Wert.Text) = 0 Then
     MsgBox Prompt:="Bitte einen k- oder T-Wert eingeben!"
     txtkfT_Wert.SetFocus
     Exit Sub
  End If
  kfT_Wert = CDbl(txtkfT_Wert.Text)
' Prfen, ob fr S_Wert ein Wert eingegeben wurde
  If Len(txtS_Wert.Text) = 0 Then
     MsgBox Prompt:="Bitte einen S-Wert eingeben!"
     txtS_Wert.SetFocus
     Exit Sub
  End If
  S_Wert = CDbl(txtS_Wert.Text)
' Prfen, ob fr Vpkt ein Wert eingegeben wurde
  If Len(txtVpkt.Text) = 0 Then
     MsgBox Prompt:="Bitte einen Volumenstrom eingeben!"
     txtVpkt.SetFocus
     Exit Sub
  End If
  Vpkt = CDbl(txtVpkt.Text)
' Prfen, ob fr Entfernung ein Wert eingegeben wurde
  If Len(txtEntfernung.Text) = 0 Then
     MsgBox Prompt:="Bitte eine Entfernung eingeben!"
     txtEntfernung.SetFocus
     Exit Sub
  End If
  Entfernung = CDbl(txtEntfernung.Text)
' Prfen, ob fr Zeitpunkt ein Wert eingegeben wurde
  If Len(txtZeitpunkt.Text) = 0 Then
     MsgBox Prompt:="Bitte einen Zeitpunkt eingeben!"
     txtZeitpunkt.SetFocus
     Exit Sub
  End If
  Zeitpunkt = CDbl(txtZeitpunkt.Text)

' Im Listenfeld wird eine berschrift ausgegeben
  lstErgebnis.AddItem Item:="kfT_Wert: " & kfT_Wert _
  & ",S_Wert: " & S_Wert & ",Volumenstrom " & Vpkt
' Entsprechend der Lnge des ersten Eintrags wird eine Linie
' mit Unterstrichen in die Liste eingefgt
  lstErgebnis.AddItem String(Len(lstErgebnis.List(lstErgebnis.NewIndex)), "_")
' Soll ein ungespannter GWL bercksichtigt werden
'W(Sigma) Berechnung
        MaxEntfernung = Entfernung
        n = 0
        EntfernungFeld(n) = MaxEntfernung / (1.5 ^ 10)
        zrn = CDbl(txtGWLArt.Text)
Do
  Sigma = (EntfernungFeld(n) * EntfernungFeld(n) * S_Wert) / (4# * kfT_Wert * zrn * Zeitpunkt)
  Wvsigma = -Log(Gamma * Sigma) + Sigma
  dif = Sigma
  num = 2
Wvsigmaberechn:
   Do
    dif = (-1) * dif * Sigma * CDbl((num - 1) / (num * num))
    Wvsigalt = Wvsigma
    Wvsigma = Wvsigma + dif
    num = num + 1
   Loop Until Abs((Wvsigma - Wvsigalt) / Wvsigma) < 0.0001
        If chkGWLArt.Value = 1 Then
        Absenk(n) = zrn - Sqr(zrn ^ 2 - Vpkt / (2# * Pi * kfT_Wert) * Wvsigma)
        Else
        Absenk(n) = Vpkt / (4# * Pi * kfT_Wert * zrn) * Wvsigma
        End If

' Ergebnis im Listenfeld anzeigen
        lstErgebnis.AddItem Item:="Entfernung:   " & Format(EntfernungFeld(n), "00.00") & " m " & "    Absenkung:   " & Format(Absenk(n), "00.00") & " m "
    n = n + 1
  EntfernungFeld(n) = EntfernungFeld(n - 1) * 1.5
Loop While EntfernungFeld(n - 1) < MaxEntfernung
  End Sub
' Beim Laden des Formulars werden die Textfelder mit
' Werten vorbelegt
Private Sub Form_Load()
    txtkfT_Wert.Text = "0,0001"
    txtS_Wert.Text = "0,001"
    txtVpkt.Text = "0,015"
    txtEntfernung = "10,00"
    txtZeitpunkt = "1000,00"
End Sub

' ********************* Ende des Programms *********************
